'''
$Log: bbsmain.py,v $
Revision 1.1.1.1  2004/02/15 08:44:28  jangc
start

Revision 1.12  2004/02/14 22:33:31  pybbs
0,1,3 are default

Revision 1.11  2004/02/14 22:04:05  pybbs
..

Revision 1.10  2004/02/08 11:06:37  pybbs
.

Revision 1.9  2004/01/18 04:31:44  pybbs
..

Revision 1.8  2004/01/08 01:21:58  pybbs
..

Revision 1.7  2004/01/04 13:49:35  pybbs
do_changeState is added
'''
#!/usr/bin/env python
import os
import cgi
import time
import traceback
import StringIO

import bbslib
import config
import pyConfigParser
from templateProcessor import templateProcessor, getTemplate

version = '0.0.1a' 

def run():
    try:
        form = cgi.FieldStorage()
        action = form.getvalue('action', 'showMainPage')
        actionFunc = globals()['do_'+action]
        ret = actionFunc(form)
        print 'Content-Type: text/html\r\n\r\n'
        print ret
    except KeyError, msg:
        print 'Content-Type: text/html\r\n\r\n'
        print errorTemplate('ERROR : action is not defined :', action)
        return
    except Exception, msg:
        print 'Content-Type: text/html\r\n\r\n'
        print getErrorMessage()
        return

def errorTemplate(msg, errorMsg=''):
    msg = msg
    template = getTemplate('error.teul')
    return templateProcessor(template, localNS=locals())

def getErrorMessage():
    s = StringIO.StringIO()
    traceback.print_exc(file=s)
    errMsg = s.getvalue()
    template = getTemplate('systemError.teul')
    msg = '''
    <table>
    <tr><td>
        <pre>%s</pre>
    </td></tr>
    </table>
    ''' % errMsg
    errorMsg = ''
    return templateProcessor(template, {}, locals())

def redirect(url):
    print 'Location: %s' % url
    print 'Content-type: text/html\r\n\r\n'
    print url

def getHtmlHeader(form, subTitle='', **kw): 
    template = getTemplate(os.path.join(config.skinPath, 'header.teul'))
    return templateProcessor(template, localNS=locals())

def getHtmlFooter(form, **kw):
    template = getTemplate(os.path.join(config.skinPath, 'footer.teul'))
    return templateProcessor(template, localNS=locals())

#######################################
# basic user's operations
def do_showMainPage(form, user=''):
    return do_showList(form)

def do_showList(form):
    sortBy = form.getvalue('sortBy', 'deadline')
    orderBy = form.getvalue('orderBy', 'asc')
    pageNo = int(form.getvalue('pageNo', 1))
    state = form.getvalue('state', ['0', '1', '3', ])
    if type(state) != type([]):
        state = [state]
    importance = form.getvalue('importance', [])
    if type(importance) != type([]):
        importance = [importance]
    conjunction = form.getvalue('conjunction', 'and')
    where = {'state':state, 'importance':importance}
    scManager = bbslib.ScheduleManager(sortBy, orderBy, pageNo, where, conjunction)
    return scManager.toHTML()

    
def do_inputSchedule(form):
    deadlineYear = form.getvalue('deadlineYear', '')
    deadlineMonth = form.getvalue('deadlineMonth', '')
    deadlineDay = form.getvalue('deadlineDay', '')
    deadlineHour = form.getvalue('deadlineHour', '')
    deadlineMin = form.getvalue('deadlineMin', '')
    importance = form.getvalue('importance', '0')
    state = form.getvalue('state', '0')
    category = form.getvalue('category', '0')
    content = form.getvalue('content', '')
    # make deadline
    if deadlineYear and deadlineMonth and deadlineDay and deadlineHour and deadlineMin:
        deadlineTuple = map(int, (deadlineYear, deadlineMonth, deadlineDay, deadlineHour, deadlineMin, 0, 0, 0, 0))
        deadline = time.strftime('%Y-%m-%d %H:%M:%S', deadlineTuple) 
    else:
        deadline = None 
    if deadline and content: 
        sc = bbslib.Schedule(importance=importance, category=category, content=content, deadline=deadline, state=state)
        sc.insert()
        redirect('todo.py')
    currentYear, currentMonth, currentDay, currentHour, currentMin = time.localtime()[:5]
    selectYear = bbslib.makeSelect('deadlineYear', range(currentYear, currentYear+5))
    selectMonth = bbslib.makeSelect('deadlineMonth', range(1, 13), selected=currentMonth)
    selectDay = bbslib.makeSelect('deadlineDay', range(1, 32), selected=currentDay)
    selectHour = bbslib.makeSelect('deadlineHour', range(0, 24))
    selectMin = bbslib.makeSelect('deadlineMin', range(0, 60)) 
    selectState = bbslib.makeSelectFromConfigInSkin('state', 'stateValue')
    selectCategory = bbslib.makeSelectFromConfigInSkin('category', 'categoryValue') 
    selectImportance = bbslib.makeSelectFromConfigInSkin('importance', 'importanceValue') 
    today = '%s %s %s' % (currentYear, currentMonth, currentDay)
    header = getHtmlHeader(form, 'Life is too short, You need python!')
    template = getTemplate(os.path.join(config.skinPath, 'input.teul'))
    footer = getHtmlFooter(form)
    return templateProcessor(header+template+footer, localNS=locals())

def do_changeState(form):
    sortBy = form.getvalue('sortBy', 'deadline')
    orderBy = form.getvalue('orderBy', 'asc')
    pageNo = int(form.getvalue('pageNo', 1))
    cState = int(form.getvalue('cState', ''))
    scheduleId = int(form.getvalue('scheduleId', ''))
    state = form.getvalue('state', [])
    importance = form.getvalue('importance', [])
    where = {'state':state, 'importance':importance}
    L = []
    for key, valueList in where.items():
        if type(valueList) == type(''):
            valueList = [valueList]
        for value in valueList:
            L.append('%s=%s' % (key, str(value)))
    bbslib.changeState(scheduleId, cState)
    redirectPath = '%s?sortBy=%s&orderBy=%s&pageNo=%s&%s' % ('todo.py', sortBy, orderBy, pageNo, '&'.join(L))
    redirect(redirectPath)

