'''
$Log: mysqlDBlib.py,v $
Revision 1.1.1.1  2004/02/15 08:44:28  jangc
start

Revision 1.6  2004/01/03 13:05:28  pybbs
getLastPage, makeQuery, getPageList are added to ScheduleManager

Revision 1.5  2004/01/02 12:29:51  pybbs
structure of skin is modified

Revision 1.4  2004/01/02 03:08:15  pybbs
trans

Revision 1.3  2003/12/31 18:28:50  pybbs
ScheduleManager
- sortBy method class is added.
- a bug of refresh method is modified

Revision 1.2  2003/12/31 09:50:50  pybbs
bbslib modified

Revision 1.1  2003/12/30 23:52:18  pybbs
pyScheduler start

'''
import MySQLdb
import config

debug = 0
g_conn = None
g_cursor = None

def extractNames(T):
    if isinstance(T, (tuple, list)):
        L = []
        for ele in T:
            L.extend(extractNames(ele))
        return L
    else:
        return [T]

def getTableNames(cursor, obj='tables'):
    cursor.execute('show %s' % obj)
    return extractNames(cursor.fetchall())

def getFieldInfo(tableName):
    cursor = getCursor()
    cursor.execute('DESCRIBE %s' % tableName)
    return cursor.fetchall()

def getAFieldInfo(tableName, fieldName):
    fieldInfoList = getFieldInfo(tableName)
    for fieldInfo in fieldInfoList:
        if fieldInfo[0] == fieldName:
            return fieldInfo
    

def getFieldNames(tableName):
    L = getFieldInfo(tableName)
    return [f[0] for f in L]

def connectDB():
    global g_conn
    if g_conn:
        return g_conn
    g_conn = MySQLdb.connect(host=config.dbhost, user=config.dbuser,
                             passwd=config.dbpasswd, db=config.dbname)
    return g_conn

def disconnectDB(connect):
    connect.close()

def getCursor():
    global g_cursor
    if g_cursor:
        return g_cursor
    conn = connectDB()
    g_cursor = conn.cursor()
    return g_cursor

def removeDB():
    db = MySQLdb.connect(host=config.dbhost, user=config.dbuser, passwd=config.dbpasswd)
    cursor = db.cursor()
    registeredDBNames = getTableNames(cursor, 'databases')
    if config.dbname in registeredDBNames:
        cursor.execute('DROP DATABASE %s' % config.dbname)
    
def makeDB():
    db = MySQLdb.connect(host=config.dbhost, user=config.dbuser, passwd=config.dbpasswd)
    cursor = db.cursor()
    registeredDBNames = getTableNames(cursor, 'databases')
    if config.dbname in registeredDBNames:
        if debug:
            print 'WARNING : DATABASE %s is already defined' % config.dbname
        return False
    else:
        if debug:
            print 'Creating DATABASE %s' % config.dbname
        cursor.execute('create database %s' % config.dbname)
        return True

def makeScheduleTable(cursor):
    cursor.execute('''CREATE TABLE %s (
        scheduleId INT NOT NULL AUTO_INCREMENT,
        importance INT,
        category INT,
        content TEXT,
        date DATETIME,
        deadline DATETIME,
        writer VARCHAR(32) NOT NULL,
        state INT,
        PRIMARY KEY(scheduleId),
        INDEX (importance),
        INDEX (writer)
        )''' % config.tableName)

def removeTable(tableName):
    cursor = getCursor()
    registeredTableNames = map(lambda name: name.lower(), getTableNames(cursor))
    if tableName.lower() in registeredTableNames:
        cursor.execute('DROP TABLE %s' % tableName)
        return True
    return False

